Lua_VideoDownMenuWindow = class("Lua_VideoDownMenuWindow", Lua_Window)
function Lua_VideoDownMenuWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_VideoDownMenuWindow"
	self.isFullSizeWin = true
	self.showBlackMask = true
	self.blackAlpha = 0.1
	self.isClickClose = true
end

function Lua_VideoDownMenuWindow:buildShowItem()
	self:superCall("buildShowItem")
	self.winBg = UICreate.createUIAtlasImage(self.content, "video_atlas", "xui_rdb_widget_5", 253.5, -471.5, 175, 272)
	self.winBg.anchorValue = 1

	self.menuList = Lua_DragList.new(self.content, 169, 262, Lua_AxisDefine.Vertical)
	self.menuList:setRectAnchor(1)
	self.menuList:setLocation(253.5, -471.5, 0)
	self.menuList.tweenId = 2004
	self.menuList.delayTween = true
	self.menuList:setListCell(Lua_VideoDownMenuItem, 169, 50, 1)
	self.menuList:setCellSpacing(0, 5)
end

function Lua_VideoDownMenuWindow:dispose()
	Lua_MsgUtil.callFunc("VIDEO_DOWN_MENU_CLOSE")
	if self.menuList then
		self.menuList:dispose()
		self.menuList = nil
	end
	self:superCall("dispose")
end

function Lua_VideoDownMenuWindow:showWin(param)
	self:superCall("showWin", param)

	self.menuList.customParam = param.index
	self.menuList:setArrayData(param.list)
	self.menuList.canDrag = not self.menuList.isTheEnd
end




















Lua_VideoDownMenuItem = class("Lua_VideoDownMenuItem", Lua_ListCell)
function Lua_VideoDownMenuItem:ctor(p)
	self:superCall("ctor", p, "VideoDownMenuItem_skin")
end

function Lua_VideoDownMenuItem:buildShowItem()
	self:superCall("buildShowItem")
end

function Lua_VideoDownMenuItem:dispose()
	self.customParam = nil
	self.data = nil
	self:superCall("dispose")
end

function Lua_VideoDownMenuItem:setCustomParam(customParam)
	self.customParam = customParam
end

function Lua_VideoDownMenuItem:setData(data)
	self.data = data
	self.nameText.text = data.name
	if data.index == self.customParam then
		self.selectedIcon:setAltas("common_altas_4", "xui_lxg_toggle_1_f")
	else
		self.selectedIcon:setAltas("common_altas_4", "xui_lxg_toggle_1_b")
	end
end

function Lua_VideoDownMenuItem:onPressClick()
	Lua_MsgUtil.callFunc("VIDEO_DOWN_MENU_SELECT", self.data)
	Lua_WindowUtil.openWin("Lua_VideoDownMenuWindow", Lua_WinParam.ACTION_CLOSE)
end