-- 录像馆
checkRequire("Lua_VideoItem");
Lua_VideosWindow = class("Lua_VideosWindow", Lua_Window);
function Lua_VideosWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.MAIN_MENU_TOP_LAYER;
	self.isFullSizeWin = true;
	self.isFullPaving = true;
	self.windowName = "Lua_VideosWindow";
	self.skinName = "VideosWindow_skin";
end

function Lua_VideosWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.winBg_2.clickScale = false;
	self.winBg_2.clickSound = nil;
	self.winBg_2:addClickFuntion(self, self.onWinBgClick);

	self.centerBgH = 892;
	self.itemListH = 845;
	self.centerBg:SetDimensions(720, self.centerBgH + self.adaptHeight);

	self:addLuaEvent("REQUEST_VIDEO_INFO", self, self.requestVideoInfo);
	self:addLuaEvent("UPDATE_VIDEO_INFO", self, self.updateVideoInfo);
	self:addLuaEvent("VIDEO_DOWN_MENU_CLOSE", self, self.onDownMenuClick);
	self:addLuaEvent("VIDEO_DOWN_MENU_SELECT", self, self.onMenuSelected);

	self.cbFilterLv.selected = false;
	self.cbFilterLv:addBoxChange(self, self.onFilterChange);

	self.bDropDownMenu = false;
	self.menuArrow:setRot(0, 0, self.bDropDownMenu and 180 or 0);
	self.menuBg:addClickFuntion(self, self.onDownMenuClick);

	self.btnInfo = Array();
	self.btnInfo:add({ textAtlas = "video_atlas", textNormalSprite = "xui_lxg_zgnbutton_1_n", textSelectedSprite = "xui_lxg_zgnbutton_1_p" });
	self.btnInfo:add({ textAtlas = "video_atlas", textNormalSprite = "xui_lxg_zgnbutton_3_n", textSelectedSprite = "xui_lxg_zgnbutton_3_p" });
	self.btnInfo:add({ textAtlas = "video_atlas", textNormalSprite = "xui_lxg_zgnbutton_2_n", textSelectedSprite = "xui_lxg_zgnbutton_2_p" });

	self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
	self.btnList:setRectAnchor(7);
	self.btnList:setLocation(183, 53, 0);
	self.btnList.pivot = -1;
	self.btnList:setButtonStyle("common_altas_1", "xui_common_zgnbutton_07", "xui_common_zgnbutton_07", 118, 118, 0.01, 1);
	self.btnList:setButtonLine("common_altas_1", "xui_common_line_001", 2, 114, 0, 0, 1);
	self.btnList:setButtonItem(118, 118);
	self.btnList:setClickCallBack(self, self.onButtonClick);
	self.btnList:setData(self.btnInfo);
	self.btnList:setSelected(1);
end

function Lua_VideosWindow:dispose()
	self.emptyRole = nil;
	self.emptyFonts = nil;
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	if self.memuArr ~= nil then
		self.memuArr:clear();
		self.memuArr = nil;
	end
	if self.typeList ~= nil then
		self.typeList:dispose();
		self.typeList = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.btnInfo ~= nil then
		self.btnInfo:clear();
		self.btnInfo = nil;
	end
	self:superCall("dispose");
end

function Lua_VideosWindow:onScreenResize()
	self:superCall("onScreenResize");
	self.centerBg:SetDimensions(720, self.centerBgH + self.adaptHeight);
	if self.itemList then
		self.itemList:setContentRect(720, self.itemListH + self.adaptHeight);
	end
end

function Lua_VideosWindow:onFilterChange(bSelect)
	self.cbFilterLv.selected = bSelect;
	self.bMoveToFirst = true
	self:requestVideoInfo();
end

function Lua_VideosWindow:onDownMenuClick(go)
	self.bDropDownMenu = not self.bDropDownMenu;
	self:updateDownMenuState();
end

function Lua_VideosWindow:updateDownMenuState()
	self.menuArrow:setRot(0, 0, self.bDropDownMenu and 180 or 0);
	if self.bDropDownMenu then
		Lua_WindowUtil.openWin("Lua_VideoDownMenuWindow", Lua_WinParam.ACTION_OPEN, { list = self.menuArr, index = self.menuSelectedIdx });
	else
		Lua_WindowUtil.openWin("Lua_VideoDownMenuWindow", Lua_WinParam.ACTION_CLOSE);
	end
end

function Lua_VideosWindow:onButtonClick(index)
	local param = DataCenter.videosUtil:getCategory(index)
	if type(param) == "table" then
		self.centerBgH = 892;
		self.arrowIcon:setLocation(-8.5, 212, 0)
		if self.typeList == nil then
			self.typeList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal, true, 680, 66)
			self.typeList:setRectAnchor(7)
			self.typeList:setLocation(0, 155, 0)
			self.typeList.clickMoveOffset = 1
			self.typeList:setButtonCell(Lua_VideoTypeItem)
			self.typeList:setButtonItem(209, 66)
			self.typeList:setClickCallBack(self, self.onTypeSelected)
		end
		self.typeList:setEnable(true)
		self.typeList:setData(param)
		self.typeList:moveToIndex(1, true)
		self.typeList:setSelected(1)
	elseif type(param) == "number" then
		self.centerBgH = 979;
		self.arrowIcon:setLocation(-8.5, 125, 0)
		if self.typeList then
			self.typeList:setEnable(false)
		end
		self:updateVideoId(param);
	end
	self.centerBg:SetDimensions(720, self.centerBgH + self.adaptHeight);
end

function Lua_VideosWindow:onTypeSelected(index, data)
	self:updateVideoId(data);
end

function Lua_VideosWindow:updateVideoId(videoId)
	self.videoId = videoId;
	self.menuData = nil;
	self.cbFilterLv.selected = false;

	self.data = DataCenter.videosUtil:getVideoConfig(videoId);
	self.cbFilterLv:setEnable(self.data.filter_near_level == 1)
	local list = self.data.arr_value;
	if list == nil or #list <= 0 then
		self.collectIcon:setEnable(true)
		self.desText:setEnable(true)
		self.menuObject:SetActive(false)

		self.bMoveToFirst = true
		self:requestVideoInfo();
	else
		self.collectIcon:setEnable(false)
		self.desText:setEnable(false)
		self.menuObject:SetActive(true)

		if self.memuArr == nil then
			self.menuArr = Array();
		else
			self.menuArr:clear();
		end
		for i = 1, #list do
			self.menuArr:add({ index = i, data = list[i], name = self.data.options_des[i] });
		end
		self:onMenuSelected(self.menuArr[1]);
	end
end

function Lua_VideosWindow:onMenuSelected(data)
	if self.menuData == data.data then
		return
	end
	self.bMoveToFirst = true
	self.menuSelectedIdx = data.index;
	self.menuText.text = data.name;
	self.menuData = data.data;
	self:requestVideoInfo();
end

function Lua_VideosWindow:requestVideoInfo()
	if self.videoId == nil then
		return;
	end

	local is_filter = self.cbFilterLv.selected == true and 1 or 0
	local condition = self.menuData == nil and 0 or self.menuData
	Lua_ProxyManager.getProxy("Lua_VideosProxy"):sVideoInfo(self.videoId, is_filter, condition);
end

function Lua_VideosWindow:updateVideoInfo()
	local data = DataCenter.videosData;

	local like_limit = DataCenter.videosUtil.like_times;
	local collect_limit = DataCenter.videosUtil.self_save_limit;
	self.likeNum.text = LanUtil.formateStr(480001, tostring(data.like_times), tostring(like_limit));
	if self.videoId == 1 then -- 个人收藏
		self.collectIcon:setEnable(true);
		self.desText.text = LanUtil.formateStr(480002, tostring(data.save_times), tostring(collect_limit));
	elseif self.videoId == 2 then -- 个人记录
		self.collectIcon:setEnable(false);
		self.desText.text = LanUtil.formateStr(480003, tostring(self.data.show_limit));
	else
		self.collectIcon:setEnable(false);
		self.desText.text = nil;
	end

	if data.videoArr == nil or data.videoArr:getSize() <= 0 then
		if self.itemList then
			self.itemList:setEnable(false);
		end
		self:showNone(true);
	else
		if self.itemList == nil then
			self.itemList = Lua_DragList.new(self.content, 625, 845, Lua_AxisDefine.Vertical);
			self.itemList:setRectAnchor(1);
			self.itemList:setRectPivot(1);
			self.itemList:setLocation(0, -350, 0);
			self.itemList.tweenId = 2009;
			self.itemList:setListCell(Lua_VideoItem, 720, 420, 1);
			self.itemList:setCellSpacing(0, -10);
		end
		self.itemList:setEnable(true);
		if self.videoId == 1 or self.videoId == 2 then
			self.itemListH = 935;
		else
			self.itemListH = 845;
		end
		self.itemList:setContentRect(720, self.itemListH + self.adaptHeight, false);
		if self.bMoveToFirst == true then
			self.itemList.showTween = true;
			self.itemList.delayTween = true;
		end
		self.itemList:setArrayData(data.videoArr);
		if self.bMoveToFirst == true then
			self.itemList:moveToIndex(1, true);
		end
		self.bMoveToFirst = false;
		self:showNone(false);
	end
end

function Lua_VideosWindow:showNone(value)
	self.arrowIcon:setEnable(not value)
	if value then
		if self.noneIcon == nil then
			self.noneIcon = UICreate.createImage(self.content, "/images/championship/xui_jys_widget_18.png", 0, -65, 0, 0);

			self.noneText = UICreate.createLabel(self.content, nil, -7, -117.5, 100, 40, 40);
			self.noneText.pivotValue = 4;
			self.noneText.fontName = Lua_MyUISettings.huakangFontName;
			self.noneText.alignmentValue = 4;
			self.noneText.horizontalOverflowValue = 1;
			self.noneText.colorStr = Lua_ColorDefine.transColorStr("7A6C74");
			self.noneText:setLangValue(480000);
		end
		self.noneIcon:setEnable(true);
		self.noneText:setEnable(true);
	else
		if self.noneIcon then
			self.noneIcon:setEnable(false);
			self.noneText:setEnable(false);
		end
	end
end




















Lua_VideoTypeItem = class("Lua_VideoTypeItem", Lua_ButtonCell)
function Lua_VideoTypeItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_VideoTypeItem:buildShowItem()
    self:superCall("buildShowItem");

    self.bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_button_005_n", 0, 0, 0, 0);

    self.title = UICreate.createLabel(self.content, nil, 0, 0, 100, 31, 34);
    self.title.pivotValue = 4;
    self.title.alignmentValue = 4;
    self.title.horizontalOverflowValue = 1;
    self.title.fontName = Lua_MyUISettings.huakangFontName;
end

function Lua_VideoTypeItem:dispose()
    if self.redPoint then
        self.redPoint:dispose();
        self.redPoint = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end

function Lua_VideoTypeItem:setData(data)
    self.data = data;
    self.title.text = DataCenter.videosUtil:getVideoConfig(data).name;
end

function Lua_VideoTypeItem:setSelected(index)
    if index == self.index then
        self.bg:setAltas("common_altas_1", "xui_common_button_004_n");
        self.title.colorStr = Lua_ColorDefine.transColor("8F5123");
    else
        self.bg:setAltas("common_altas_1", "xui_common_button_005_n");
        self.title.colorStr = Lua_ColorDefine.transColor("756150");
    end
end